#ifndef NEXTINFO_H
	#define NEXTINFO_H


#include <qguardedptr.h>
#include <qobject.h>
#include <qtimer.h>
#include <qvaluelist.h>

#include "action.h"
#include "configuration_aware_object.h"
#include "main_configuration_window.h"

#include "defines.h"
#include "extendedinformationwindow.h"


class NExtInfo : public ConfigurationUiHandler, ConfigurationAwareObject
{
	Q_OBJECT
	public:
		NExtInfo();
		~NExtInfo();
		void mainConfigurationWindowCreated( MainConfigurationWindow *mainConfigurationWindow );
	public slots:
		void userboxMenuPopup();
		void showExtendedInformationWindow();
		void notifyBirthdayNameday();
		void dontInformAboutTheBirthday(); void informAboutTheBirthday();
		void dontInformAboutTheNameday(); void informAboutTheNameday();
		void showHelp();
		void importDataFromExtInfo();
	protected:
		void configurationUpdated();
	private:
		void createDefaultConfiguration();
		QPair<bool,UserListElement> getUserBoxSelectedUser();
		QPair< bool, QPair<int,int> > checkBirthday( UserListElement user );
		QPair< bool, QPair<int,int> > checkNameday( UserListElement user );
		int closestYear( int month, int day );
		QValueList< QGuardedPtr<ExtendedInformationWindow> > extendedinformationwindows;
		int popupmenu_item_separator, popupmenu_item_extinfo,
		    popupmenu_item_birthdaydontinform, popupmenu_item_birthdayinform,
		    popupmenu_item_namedaydontinform, popupmenu_item_namedayinform;
		QTimer *birthdaynamedaytimer;
		Action *nextinfoaction;
		bool notify;                // configuration value
		bool notifyAboutBirthdays;  // configuration value
		bool notifyAboutNamedays;   // configuration value
		int  notifyAdvance;         // configuration value
		int  notifyInterval;        // configuration value
	private slots:
		void nextinfoactionActivated( const UserGroup *usergroup );
};


extern NExtInfo *nextinfo;


#endif
